MODULE RSTACK3;

FROM RSTACKELEMENT 
   IMPORT StackElement, Operators, IsOperator, GetOperator;
FROM RSTACKINOUT IMPORT Input, Output;
FROM CALCSTACK IMPORT CalcStack, Create, Push, Pop, Top, Destroy;
FROM CALCOPERATION IMPORT Calculate;

FROM InOut
   IMPORT WriteString, WriteLn;

VAR Element,
    firstOperand,
    secondOperand : StackElement;
    TheCalcStack  : CalcStack;
    stop          : BOOLEAN;

BEGIN
   Create (TheCalcStack);
   REPEAT
      Input (Element);
      IF IsOperator (Element) THEN
         secondOperand := Top (TheCalcStack); Output (secondOperand);
         Pop (TheCalcStack);
         firstOperand := Top (TheCalcStack); Output (firstOperand);
         Pop (TheCalcStack);
         Push (TheCalcStack,
            Calculate (firstOperand,Element,secondOperand));
         WriteString ("** Ergebnis: "); Output (Top(TheCalcStack))
      ELSE
         Push (TheCalcStack,Element);
      END (* IF *);
      stop := (GetOperator (Element) = res);
   UNTIL stop;
   Destroy (TheCalcStack)
END RSTACK3.
